﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;


/* 
   DIGITS : H G F E D C B A
   NUMBER : 7 6 5 4 3 2 1 0 
*/

namespace SevenSegmentUtility
{
    public partial class Form1 : Form
    {
        private bool[] selected;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            selected = new bool[8] { false, false, false, false, false, false, false, false };
            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private byte Calculate()
        {
            byte result = 0x00;
            for (int i = 0; i < selected.Length - 1; i++)
            {
                if (selected[i])
                    result = (byte)(result | ((byte)Math.Pow(2, i)));
            }
            if (selected[7])
            {
                result = (byte)(result | 0x80);
            }
            if (checkBox1.Checked)
            {
                result = (byte)(~result);
            }
            return result;
        }

        private void a_Click(object sender, EventArgs e)
        {
            selected[0] = !selected[0];
            if (selected[0])
                a.BackColor = Color.Red;
            else
                a.BackColor = Color.FromKnownColor(KnownColor.Control);

            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private void b_Click(object sender, EventArgs e)
        {
            selected[1] = !selected[1];
            if (selected[1])
                b.BackColor = Color.Red;
            else
                b.BackColor = Color.FromKnownColor(KnownColor.Control);
            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private void c_Click(object sender, EventArgs e)
        {
            selected[2] = !selected[2];
            if (selected[2])
                c.BackColor = Color.Red;
            else
                c.BackColor = Color.FromKnownColor(KnownColor.Control);
            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private void d_Click(object sender, EventArgs e)
        {
            selected[3] = !selected[3];
            if (selected[3])
                d.BackColor = Color.Red;
            else
                d.BackColor = Color.FromKnownColor(KnownColor.Control);
            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private void ee_Click(object sender, EventArgs e)
        {
            selected[4] = !selected[4];
            if (selected[4])
                ee.BackColor = Color.Red;
            else
                ee.BackColor = Color.FromKnownColor(KnownColor.Control);
            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private void f_Click(object sender, EventArgs e)
        {
            selected[5] = !selected[5];
            if (selected[5])
                f.BackColor = Color.Red;
            else
                f.BackColor = Color.FromKnownColor(KnownColor.Control);
            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private void g_Click(object sender, EventArgs e)
        {
            selected[6] = !selected[6];
            if (selected[6])
                g.BackColor = Color.Red;
            else
                g.BackColor = Color.FromKnownColor(KnownColor.Control);
            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private void h_Click(object sender, EventArgs e)
        {
            selected[7] = !selected[7];
            if (selected[7])
                h.BackColor = Color.Red;
            else
                h.BackColor = Color.FromKnownColor(KnownColor.Control);
            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }

        private void aboutToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Seven Segment Utility", "Seven Segment Utility", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void contactToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Website : www.softelectrotech.com\nContact : nart@softelectrotech.com", "Seven Segment Utility", MessageBoxButtons.OK, MessageBoxIcon.Information);
        }

        private void checkBox1_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBox1.Checked)
                checkBox1.Text = "Common Anode";
            else
                checkBox1.Text = "Common Cathod";


            byte res = Calculate();
            textBox1.Text = res.ToString();
            textBox2.Text = Convert.ToString(res, 2);
            textBox3.Text = "0X" + res.ToString("X2");
        }
    }
}
